exec("./Support_AdminEvents.cs");

registerOutputEvent(Player, TeleportToSpawn, "int 1 3600000 10000" TAB "bool");
registerAdminOnlyOutputEvent(Player, TeleportToSpawn, 1);

function Player::TeleportToSpawn(%this, %ms, %msg)
{
	cancel(%this.TeleportToSpawn[1]);
	cancel(%this.TeleportToSpawn[2]);
	%this.TeleportToSpawn[1] = %this.schedule(%ms, TeleportToSpawn_tele);
	if(%msg)
	{
		%seconds = %ms / 1000;
		%minutes = %seconds / 60;
		if(mFloor(%minutes) == %minutes)
		{
			%pf = "minute";
			%time = %minutes;
			if(%minutes != 1)
			{
				%sf = "s";
			}
		}
		else if(mFloor(%seconds) == %seconds)
		{
			%pf = "second";
			%time = %seconds;
			if(%seconds != 1)
			{
				%sf = "s";
			}
		}
		else
		{
			%pf = "millisecond";
			%time = %ms;
			if(%ms != 1)
			{
				%sf = "s";
			}
		}
		messageClient(%this.client, '', "\c6You will be brought back to your spawn in\c4" SPC %time SPC "\c6" @ %pf @ %sf @ ".");
		%this.TeleportToSpawn[2] = schedule(%ms, 0, messageClient, %this.client, '', "\c6You have been brought back to your spawn.");
	}
}

package TeleportToSpawn
{
	function gameConnection::spawnPlayer(%this)
	{
		Parent::spawnPlayer(%this);
		%this.player.schedule(33, saveSpawnPosition);
	}
};

activatePackage(TeleportToSpawn);

function Player::saveSpawnPosition(%this)
{
	%this.spawnPosition = %this.getPosition();
}

function Player::TeleportToSpawn_tele(%this)
{
	%this.spawnExplosion(49, "1 1 1");
	%this.setTransform(%this.spawnPosition);
	%this.spawnExplosion(56, "1 1 1");
}